chiark / gitweb /
add ignore patterns for quilt and debian build
[topgit.git] / tg.sh
diff --git a/tg.sh b/tg.sh
index 2294a99250b220ee5eed62b2465490948fb5ad23..2961106f735402d695043f31b32ffdef298566b3 100644 (file)
--- a/tg.sh
+++ b/tg.sh
@@ -20,13 +20,13 @@ die()
 # setup_hook NAME
 setup_hook()
 {
-       hook_call="\"\$(tg --hooks-path)\"/$1 \"\$@\""
+       hook_call="\"\$($tg --hooks-path)\"/$1 \"\$@\""
        if [ -f "$git_dir/hooks/$1" ] &&
           fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
                # Another job well done!
                return
        fi
-       # Prepare incanation
+       # Prepare incantation
        if [ -x "$git_dir/hooks/$1" ]; then
                hook_call="$hook_call"' || exit $?'
        else
@@ -77,7 +77,7 @@ measure_branch()
 # Whether B1 is a superset of B2.
 branch_contains()
 {
-       [ -z "$(git rev-list ^"$1" "$2")" ]
+       [ -z "$(git rev-list ^"$1" "$2" --)" ]
 }
 
 # ref_exists REF
@@ -222,10 +222,14 @@ do_help()
                        sep="|"
                done
 
-               echo "TopGit v0.2 - A different patch queue manager"
+               echo "TopGit v0.5 - A different patch queue manager"
                echo "Usage: tg [-r REMOTE] ($cmds|help) ..."
-       elif [ -r "@sharedir@/tg-$1.txt" ] ; then
-               cat "@sharedir@/tg-$1.txt"
+       elif [ -r "@cmddir@"/tg-$1 ] ; then
+               @cmddir@/tg-$1 -h || :
+               echo
+               if [ -r "@sharedir@/tg-$1.txt" ] ; then
+                       cat "@sharedir@/tg-$1.txt"
+               fi
        else
                echo "`basename $0`: no help for $1" 1>&2
        fi
@@ -237,7 +241,10 @@ do_help()
 set -e
 git_dir="$(git rev-parse --git-dir)"
 root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
+# Make sure root_dir doesn't end with a trailing slash.
+root_dir="${root_dir%/}"
 base_remote="$(git config topgit.remote 2>/dev/null)" || :
+tg="tg"
 # make sure merging the .top* files will always behave sanely
 setup_ours
 setup_hook "pre-commit"
@@ -253,6 +260,7 @@ setup_hook "pre-commit"
 
 if [ "$1" = "-r" ]; then
        shift; base_remote="$1"; shift
+       tg="$tg -r $base_remote"
 fi
 
 cmd="$1"